#!/usr/bin/perl -wT
# Copyright (C)2001 by Arne Bochem <webmaster@heinz99.de> http://heinz99.de/
# Don't ever remove this notice.

use strict;

my $datafile = 'counterdata'; # The databasefile[prefix] name
my $ipblock = 30*60;          # Number of seconds an IP will be blocked for
                              # counting.

# Code starts here.
my %counterdata;
my $ip = $ENV{'REMOTE_ADDR'} || die('No IP detected.');
my $now = time();
($ip =~ /[^\.0-9\:]/) and die('Illegal IP detected.');

dbmopen(%counterdata, $datafile, 0700);

foreach my $key (keys %counterdata)
{
	(($key =~ /^[\.0-9\:]$/) && ($counterdata{$key} < ($now - $ipblock)))
		and delete($counterdata{$key});
}

$counterdata{$ip} and printOutput();
$counterdata{$ip} = $now;
$counterdata{'counter'}++;
printOutput();

dbmclose(%counterdata);

sub printOutput
{
	print 'Content-Type: text/html'."\n\n",
		$counterdata{'counter'};
	exit();
}
